<!doctype html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="description" content="">
  <meta name="author" content="Mark Otto, Jacob Thornton, and Bootstrap contributors">
  <meta name="generator" content="Hugo 0.101.0">
  <title>Sign-up1</title>

  <link rel="canonical" href="https://getbootstrap.com/docs/4.6/examples/sign-in/">


  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>




  <style>
    .bd-placeholder-img {
      font-size: 1.125rem;
      text-anchor: middle;
      -webkit-user-select: none;
      -moz-user-select: none;
      -ms-user-select: none;
      user-select: none;
    }

    @media (min-width: 768px) {
      .bd-placeholder-img-lg {
        font-size: 3.5rem;
      }
    }
  </style>


  <!-- Custom styles for this template -->
  <link href="../css/signup.css" rel="stylesheet">
</head>

<body class="">

  <form class="form-signin border border-black-50" onsubmit="return false;">
    <h1 class="h3 mb-4 font-weight-normal font-weight-bold  mt-5 ">Sign-up</h1>
    <p>please fill in this from to create an account </p>
    <hr>
    <!-- class="sr-only" áp dụng cho trình đọc màn hình .. dành cho người mù  -->
    <label for="inputEmail" class="sr-only">User Name</label>
    <input type="text" id="inputUsername" class="form-control mb-3" placeholder="User Name" required autofocus>

    <label for="inputPassword" class="sr-only">Email</label>
    <input type="email" id="inpEmail" class="form-control mb-3" placeholder="Email" required>

    <label for="inputPassword" class="sr-only">Password</label>
    <input type="password" id="input-password" class="form-control mb-3" placeholder="Password" required>

    <label for="inputPassword" class="sr-only"> Confirm Password</label>
    <input type="password" id="input-password-confirm" class="form-control mb-3" placeholder="Confirm Password" required>

    <div class="checkbox mb-3">
      <label>
        <input type="checkbox" value="remember-me"> I accept the Terms of use & privacy policy
      </label>
    </div>
    <button id="btn-signup" class="btn btn-lg btn-primary btn-block mb-5" type="submit">Sign up</button>
  </form>



</body>

<script>

  $(document).ready(function () {


    
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  
    
/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    

/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/  
    //----Phần này làm sau khi đã làm trang info.js
    //Kiểm tra token nếu có token tức người dùng đã đăng nhập
    const token = getCookie("token");

    if (token) {
      console.log(token);
      window.location.href = "./user-info/info.html";
    }
    //----Phần này làm sau khi đã làm trang info.js
    console.log("token : " + token);


 


    //Sự kiện bấm nút sign up   
    $("#btn-signup").on("click", function () {
      console.log("sign up");
      var username = $("#inputUsername").val().trim();
      var email = $("#inpEmail").val().trim();

      var password = $("#input-password").val().trim();
      var passwordConfirm = $("#input-password-confirm").val().trim();

      if (validateForm(username,email, password, passwordConfirm)) {
        console.log(username,email, password, passwordConfirm);
        signUpFunction(username,email, password);
      }
    });



    function signUpFunction(username,email, password) {
      var vSignUpData = {
        username: username,
        email: email,
        password: password
      }

      $.ajax({
        url: "http://localhost:8080/api/auth/signup",
        type: 'POST',
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify(vSignUpData),
        success: function (pRes) {
          console.log(pRes)
          responseHandler(pRes);
        },
        error: function (pAjaxContext) {
          console.log(pAjaxContext.responseJSON.message);
        }
      });
    }






    //Xử lý object trả về khi login thành công
    function responseHandler(data) {
      //Lưu token vào cookie trong 1 ngày
      setCookie("token", data.accessToken, 1);

      window.location.href = "../user-info/info.html";
    }

    //Hàm setCookie đã giới thiệu ở bài trước
    function setCookie(cname, cvalue, exdays) {
      var d = new Date();
      d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
      var expires = "expires=" + d.toUTCString();
      document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    }

    //Hiển thị lỗi lên form 
    function showError(message) {
      var errorElement = $("#error");

      errorElement.html(message);
      errorElement.addClass("d-block");
      errorElement.addClass("d-none");
    }

    //Validate dữ liệu từ form
    function validateForm(username,email, password, passwordConfirm ) {
      if (username === "") {
        alert("Username không phù hợp");
        return false;
      };

      if (email === "") {
        alert("email không phù hợp");
        return false;
      }
      if (password === "") {
        alert("Password không phù hợp");
        return false;
      }
      if (passwordConfirm === "") {
        alert("password confirm không phù hợp");
        return false;
      }

      if (passwordConfirm != password) {
        alert("Password và confirm password phải giống nhau "); 
        return false;
      }

      return true;
    }

    //Hàm get Cookie đã giới thiệu ở bài trước
    function getCookie(cname) {
      var name = cname + "=";
      var decodedCookie = decodeURIComponent(document.cookie);
      var ca = decodedCookie.split(';');
      for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
          c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
          return c.substring(name.length, c.length);
        }
      }
      return "";
    }
  });
</script>

</html>